<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Louvain Algorithm: src/graph.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Louvain Algorithm
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">graph.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="graph_8h__dep__incl.png" border="0" usemap="#src_2graph_8hdep" alt=""/></div>
<map name="src_2graph_8hdep" id="src_2graph_8hdep">
<area shape="rect" id="node2" href="community_8h.html" title="src/community.h" alt="" coords="72,80,191,107"/>
<area shape="rect" id="node3" href="community_8c.html" title="src/community.c" alt="" coords="5,155,124,181"/>
<area shape="rect" id="node4" href="louvain_8c.html" title="src/louvain.c" alt="" coords="165,155,261,181"/>
<area shape="rect" id="node5" href="graph_8c.html" title="src/graph.c" alt="" coords="267,80,353,107"/>
</map>
</div>
</div>
<p><a href="graph_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structgnode__t.html">gnode_t</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structgraph__t.html">graph_t</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structedge__t.html">edge_t</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:abd2aacdca9cb2a1a30f3392256b96ea3"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#abd2aacdca9cb2a1a30f3392256b96ea3">MAX_NODES</a>&#160;&#160;&#160;100000</td></tr>
<tr class="separator:abd2aacdca9cb2a1a30f3392256b96ea3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:a01bbf2d3f333d81f684ee814292b42b2"><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="structgnode__t.html">gnode_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#a01bbf2d3f333d81f684ee814292b42b2">gnode_t</a></td></tr>
<tr class="separator:a01bbf2d3f333d81f684ee814292b42b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a595dd93a0717173364e453106ddb452b"><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="structgraph__t.html">graph_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#a595dd93a0717173364e453106ddb452b">graph_t</a></td></tr>
<tr class="separator:a595dd93a0717173364e453106ddb452b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abbf769d3c3cb1aa4496b8671ace4075c"><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="structedge__t.html">edge_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#abbf769d3c3cb1aa4496b8671ace4075c">edge_t</a></td></tr>
<tr class="separator:abbf769d3c3cb1aa4496b8671ace4075c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:aa4a2c58cf35124509c40dea83129ac93"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#aa4a2c58cf35124509c40dea83129ac93">create_graph</a> (<a class="el" href="structedge__t.html">edge_t</a> *edges, int n)</td></tr>
<tr class="separator:aa4a2c58cf35124509c40dea83129ac93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa06aa604e7ce71847f52d0225ecc43d0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#aa06aa604e7ce71847f52d0225ecc43d0">num_vertices</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g)</td></tr>
<tr class="separator:aa06aa604e7ce71847f52d0225ecc43d0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16b6212a05e5662ccfd37199d50c637a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#a16b6212a05e5662ccfd37199d50c637a">num_edges</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g)</td></tr>
<tr class="separator:a16b6212a05e5662ccfd37199d50c637a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1894d26ea89ef5de84d17c3c2befd70c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#a1894d26ea89ef5de84d17c3c2befd70c">print_graph</a> (<a class="el" href="structgraph__t.html">graph_t</a> *)</td></tr>
<tr class="separator:a1894d26ea89ef5de84d17c3c2befd70c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9d32135f75dc83ddf7f04ebedc915239"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#a9d32135f75dc83ddf7f04ebedc915239">degree</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g, int node_id)</td></tr>
<tr class="separator:a9d32135f75dc83ddf7f04ebedc915239"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a060b402e39855ced428216b327b030a5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#a060b402e39855ced428216b327b030a5">add_edge</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g, <a class="el" href="structedge__t.html">edge_t</a> e)</td></tr>
<tr class="separator:a060b402e39855ced428216b327b030a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a564fd8433c014fded5dfe9b0d5f9aa30"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#a564fd8433c014fded5dfe9b0d5f9aa30">remove_edge</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g, <a class="el" href="structedge__t.html">edge_t</a> e)</td></tr>
<tr class="separator:a564fd8433c014fded5dfe9b0d5f9aa30"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a151f5b250afc78268f7034af24a8f40f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="graph_8h.html#a151f5b250afc78268f7034af24a8f40f">clean_graph</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g)</td></tr>
<tr class="separator:a151f5b250afc78268f7034af24a8f40f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="abd2aacdca9cb2a1a30f3392256b96ea3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abd2aacdca9cb2a1a30f3392256b96ea3">&#9670;&nbsp;</a></span>MAX_NODES</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define MAX_NODES&#160;&#160;&#160;100000</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The maximum number of nodes that the graph can contain. </p>

</div>
</div>
<h2 class="groupheader">Typedef Documentation</h2>
<a id="abbf769d3c3cb1aa4496b8671ace4075c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abbf769d3c3cb1aa4496b8671ace4075c">&#9670;&nbsp;</a></span>edge_t</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="structedge__t.html">edge_t</a>  <a class="el" href="structedge__t.html">edge_t</a></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a01bbf2d3f333d81f684ee814292b42b2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a01bbf2d3f333d81f684ee814292b42b2">&#9670;&nbsp;</a></span>gnode_t</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="structgnode__t.html">gnode_t</a>  <a class="el" href="structgnode__t.html">gnode_t</a></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a595dd93a0717173364e453106ddb452b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a595dd93a0717173364e453106ddb452b">&#9670;&nbsp;</a></span>graph_t</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="structgraph__t.html">graph_t</a>  <a class="el" href="structgraph__t.html">graph_t</a></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a060b402e39855ced428216b327b030a5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a060b402e39855ced428216b327b030a5">&#9670;&nbsp;</a></span>add_edge()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void add_edge </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structedge__t.html">edge_t</a>&#160;</td>
          <td class="paramname"><em>e</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to insert a new edge in a given graph. It has to add the edge both in the source vertex and in the destination edge's list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The graph one wants to modify. </td></tr>
    <tr><td class="paramname">e</td><td>The edge that one wants to add. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a151f5b250afc78268f7034af24a8f40f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a151f5b250afc78268f7034af24a8f40f">&#9670;&nbsp;</a></span>clean_graph()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void clean_graph </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to free all allocated memory for the graph. It iteratively frees memory for all edges, then for all vertices and then for the graph itself. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The graph one wants to remove. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aa4a2c58cf35124509c40dea83129ac93"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa4a2c58cf35124509c40dea83129ac93">&#9670;&nbsp;</a></span>create_graph()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structgraph__t.html">graph_t</a>* create_graph </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structedge__t.html">edge_t</a> *&#160;</td>
          <td class="paramname"><em>edges</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>A function to create a graph starting from the edges in format source - destination. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">edges</td><td>The array of edges of the graph you want to create. </td></tr>
    <tr><td class="paramname">n</td><td>The number of edges contained in the array. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the graph. </dd></dl>

</div>
</div>
<a id="a9d32135f75dc83ddf7f04ebedc915239"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9d32135f75dc83ddf7f04ebedc915239">&#9670;&nbsp;</a></span>degree()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int degree </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>node_id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to calculate the weighted degree of a node.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The pointer to the graph which contains the node. </td></tr>
    <tr><td class="paramname">node_id</td><td>The index of the node. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The weighted degree of the given node. </dd></dl>

</div>
</div>
<a id="a16b6212a05e5662ccfd37199d50c637a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a16b6212a05e5662ccfd37199d50c637a">&#9670;&nbsp;</a></span>num_edges()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int num_edges </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to return the number of edges in the graph. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The graph one wants to know the number of edges. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The number of edges. </dd></dl>

</div>
</div>
<a id="aa06aa604e7ce71847f52d0225ecc43d0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa06aa604e7ce71847f52d0225ecc43d0">&#9670;&nbsp;</a></span>num_vertices()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int num_vertices </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to return the number of vertices in the graph. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The graph one wants to know the number of vertices. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The number of vertices. </dd></dl>

</div>
</div>
<a id="a1894d26ea89ef5de84d17c3c2befd70c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1894d26ea89ef5de84d17c3c2befd70c">&#9670;&nbsp;</a></span>print_graph()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void print_graph </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to print to stdout the adjacency list of every node in the graph. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>the graph one wants to print </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a564fd8433c014fded5dfe9b0d5f9aa30"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a564fd8433c014fded5dfe9b0d5f9aa30">&#9670;&nbsp;</a></span>remove_edge()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void remove_edge </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structedge__t.html">edge_t</a>&#160;</td>
          <td class="paramname"><em>e</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to remove an edge from a given graph. It removes the edge from both the vertices' lists that were involved in the connection. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The origin graph. </td></tr>
    <tr><td class="paramname">e</td><td>The edge one wants to remove. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
